/*
Copyright (C) 2004-2023 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004-2023 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: progress dialog
//-----------------------------------------------------------------------------

#pragma once

#include "../tools/GUI/Dialog/DialogText.h"
#include "../tools/GUI/ComboBox/Combobox.h"
#include "../tools/String/OutputString.h"



class CDialogCommandLineWizard:public CDialogText,public CComboboxEventsBase
{
protected:
    // CDialogBase
    virtual BOOL OnInit();
    virtual BOOL OnClose();
    virtual void OnCommand(WPARAM wParam,LPARAM lParam);
    virtual void OnSizing(WPARAM wParam,LPARAM lParam);

    // CDialogText
    virtual void Resize();

    typedef enum ComboOperations
    {
        ComboOperations_Replace=0,
        ComboOperations_Search,
        ComboOperations_SearchDead
    };

    typedef enum ComboPostSearchOperations
    {
        ComboPostSearchOperations_None=0,
        ComboPostSearchOperations_Resolve,
        ComboPostSearchOperations_Delete
    };
    

    // CComboboxEventsBase
    virtual void OnComboBoxSelectionChanged(CCombobox* pSender,int SelectionIndex);

    // CDialogCommandLineWizard
    BOOL Save();

    void ShowPostOperation(BOOL bShowPostOperation);
    void AppendPostOperation(IN OUT COutputString* pOutputString);
    void UpdateCmdLine();

    CCombobox ComboboxOperation;
    CCombobox ComboboxPostOperation;
    COutputString* pStrCmdLineReplace;
    COutputString* pStrCmdLineSearch;
    COutputString* pStrCmdLineSearchDead;
    COutputString StrCmdLine;
public:
    CDialogCommandLineWizard(COutputString* pStrCmdLineReplace,COutputString* pStrCmdLineSearch,COutputString* pStrCmdLineSearchDead,
                             HINSTANCE hInstance,HWND hWndParentDialog,int DialogResourceId,int IconResourceId,int EditResourceId);
    virtual ~CDialogCommandLineWizard();
};
