#pragma once

#include <windows.h>
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)

#pragma warning (push)
#pragma warning(disable : 4995)
#include <regex>
#pragma warning (pop)

// MSVC++ 10.0  _MSC_VER == 1600 (Visual Studio 2010 version 10.0)
// MSVC++ 9.0   _MSC_FULL_VER == 150030729 (Visual Studio 2008, SP1)
// MSVC++ 9.0   _MSC_VER == 1500 (Visual Studio 2008 version 9.0)
#ifdef _MSC_VER
    #if (_MSC_VER < 1600)
        #if (_MSC_VER < 1500)
            #error "vs 2008 sp1 required for std::regex"
        #else
            #if (_MSC_FULL_VER<150030729)
                #error "vs 2008 sp1 required for std::regex"
            #else
                #define REGEX_NAMESPACE std::tr1
            #endif
        #endif
    #else
        #define REGEX_NAMESPACE     std
    #endif
#else
    #define REGEX_NAMESPACE     std
#endif

#if (defined(UNICODE)||defined(_UNICODE))
    #define tregex  REGEX_NAMESPACE::wregex 
    #define tstring std::wstring
    #define tsregex_iterator wsregex_iterator
    #define tsmatch wsmatch
#else
    #define tregex  REGEX_NAMESPACE::regex 
    #define tstring std::string
    #define tsregex_iterator sregex_iterator
    #define tsmatch smatch
#endif

class CRegularExpression
{
protected:
    tregex* pRegExpr;

    TCHAR RegExprErrorMessage[256];
public:
    CRegularExpression(TCHAR* RegExpression);
    ~CRegularExpression();
    BOOL IsRegExpressionValid();

    BOOL DoesMatch(TCHAR* String);
    BOOL DoesMatchEx(TCHAR* String,OUT BOOL* bMatch,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);

    static BOOL DoesMatch(TCHAR* String,TCHAR* RegExpression);
    static BOOL DoesMatchEx(TCHAR* String,TCHAR* RegExpression,OUT BOOL* bMatch,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);

    tstring Replace(TCHAR* String,TCHAR* StrReplace);
    tstring ReplaceEx(TCHAR* String,TCHAR* StrReplace,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);
    
    tstring Replace(tstring String,tstring StrReplace);
    tstring ReplaceEx(tstring String,tstring StrReplace,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);

    static tstring Replace(TCHAR* String,TCHAR* RegExpression,TCHAR* StrReplace);
    static tstring ReplaceEx(TCHAR* String,TCHAR* RegExpression,TCHAR* StrReplace,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);
    
    static tstring Replace(tstring String,tstring RegExpression,tstring StrReplace);
    static tstring ReplaceEx(tstring String,tstring RegExpression,tstring StrReplace,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);

    typedef BOOL (*pfCallBackMatchFound)(REGEX_NAMESPACE::tsmatch* pSingleMatch,PVOID UserParam);
    
    BOOL MultipleMatch(TCHAR* Content,pfCallBackMatchFound CallBackFunction,PVOID UserParam);
    BOOL MultipleMatchEx(TCHAR* Content,pfCallBackMatchFound CallBackFunction,PVOID UserParam,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);
    
    BOOL MultipleMatch(tstring Content,pfCallBackMatchFound CallBackFunction,PVOID UserParam);
    BOOL MultipleMatchEx(tstring Content,pfCallBackMatchFound CallBackFunction,PVOID UserParam,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);

    static BOOL MultipleMatch(TCHAR* Content,TCHAR* RegExpression,pfCallBackMatchFound CallBackFunction,PVOID UserParam);
    static BOOL MultipleMatchEx(TCHAR* Content,TCHAR* RegExpression,pfCallBackMatchFound CallBackFunction,PVOID UserParam,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);
    
    static BOOL MultipleMatch(tstring Content,tstring RegExpression,pfCallBackMatchFound CallBackFunction,PVOID UserParam);
    static BOOL MultipleMatchEx(tstring Content,tstring RegExpression,pfCallBackMatchFound CallBackFunction,PVOID UserParam,OUT TCHAR* ErrorMessage, IN SIZE_T ErrorMessageMaxLen);
};